diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/STATUS anaconda-storage/storage/STATUS
--- anaconda/storage/STATUS	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/STATUS	2009-02-13 00:15:44.000000000 -0600
@@ -0,0 +1,53 @@
+Fri Feb 13 00:04:17 CST 2009
+
+Moved all code with knowledge of the Device/DeviceTree/DeviceFormat
+classes back into DeviceTree (addUdevDevice). Made little functions
+in udev.py to grab specific pieces of device information. Added lots of
+type assurances throughout the udev functions.
+
+I think I finally got LVM Device/DeviceFormat classes sorted out as far
+as space calculations.
+
+Began to merge into anaconda (in storage/), including a new layout.
+
+Sorted out most things with upgrade, rescue.
+
+FSTab class has turned into FSSet. Not sure how I feel about it. I need
+to decide how that's going to be. It might be the biggest remaining part
+of the merge.
+
+After FSSet is sorted out it will be time to tackle fleshing out
+DeviceTree (or whatever will replace Partitions), doAutoPart, and
+integration with the UI. After that, who knows...
+
+Tue Feb 10 22:34:01 CST 2009
+
+Autopart is working pretty well with one disk, although I'm hitting some
+segfaults when clearing empty extended partitions. I have had success
+with and without preexisting partitions. Growth amounts appear to be
+correct, except that I don't think I have covered the case of base size
+being zero with grow set. The case where we create an extended partition
+during autopart is also not handled gracefully since we do not have access
+to the device tree inside the autopart functions.
+
+LV/VG growing is well on its way, but I need to flesh out the VG, LV
+device classes before I can test it.
+
+Top items on TODO list are lvm, merge w/ anaconda, then dmraid, mpath.
+
+Fri Feb  6 19:47:58 CST 2009
+
+Clearpart seems to be working well, including removal of dependent devices
+like VGs, LVs, and md arrays.
+
+Populating the tree seems to work well both for running systems and from
+scratch. There are some hitches with udev knowing what's changed, though.
+It might be time to reconnect the notify_kernel function so it sends
+uevents again.
+
+Some basic tests have been successful: creating and destroying both lvm
+and md devices, creating and removing various device formats, and
+clearing of partitions and their dependent devices.
+
+Next thing to do is partitioning...
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/storage_log.py anaconda-storage/storage/storage_log.py
--- anaconda/storage/storage_log.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/storage_log.py	2009-02-12 16:17:59.000000000 -0600
@@ -0,0 +1,13 @@
+import logging
+
+
+#handler = logging.StreamHandler()
+handler = logging.FileHandler("/tmp/storage.log")
+formatter = logging.Formatter("[%(asctime)s] %(levelname)8s: %(message)s")
+handler.setFormatter(formatter)
+
+logger = logging.getLogger("storage")
+logger.addHandler(handler)
+logger.setLevel(logging.DEBUG)
+
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/storage/udev.py anaconda-storage/storage/udev.py
--- anaconda/storage/udev.py	1969-12-31 18:00:00.000000000 -0600
+++ anaconda-storage/storage/udev.py	2009-02-12 16:17:59.000000000 -0600
@@ -0,0 +1,273 @@
+# udev.py
+# Python module for querying the udev database for device information.
+#
+# Copyright (C) 2009  Red Hat, Inc.
+#
+# This copyrighted material is made available to anyone wishing to use,
+# modify, copy, or redistribute it subject to the terms and conditions of
+# the GNU General Public License v.2, or (at your option) any later version.
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY expressed or implied, including the implied warranties of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
+# Public License for more details.  You should have received a copy of the
+# GNU General Public License along with this program; if not, write to the
+# Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.  Any Red Hat trademarks that are incorporated in the
+# source code or documentation are not subject to the GNU General Public
+# License and may only be used or replicated with the express permission of
+# Red Hat, Inc.
+#
+# Red Hat Author(s): Dave Lehman <dlehman@redhat.com>
+#
+
+import os
+import re
+
+import iutil
+
+import logging
+log = logging.getLogger("storage")
+
+
+def udev_get_block_devices():
+    udev_settle(timeout=2)
+    entries = []
+    for path in enumerate_block_devices():
+        entry = udev_get_block_device(path)
+        if entry:
+            entries.append(entry)
+    return entries
+
+def enumerate_block_devices():
+    top_dir = "/sys/class/block"
+    devices = []
+    for dev_name in os.listdir(top_dir):
+        if dev_name.startswith("loop") or dev_name.startswith("ram"):
+            continue
+        full_path = os.path.join(top_dir, dev_name)
+        link_ref = os.readlink(full_path)
+        real_path = os.path.join(top_dir, link_ref)
+        sysfs_path = os.path.normpath(real_path)
+        devices.append(sysfs_path)
+    return devices
+
+def udev_get_block_device(sysfs_path):
+    log.debug("getting udev info for %s" % sysfs_path)
+    if not os.path.exists(sysfs_path):
+        log.debug("%s does not exist" % sysfs_path)
+        return None
+
+    db_entry = sysfs_path[4:].replace("/", "\\x2f")
+    db_root = "/dev/.udev/db"
+    db_path = os.path.normpath("%s/%s" % (db_root, db_entry))
+    if not os.access(db_path, os.R_OK):
+        log.debug("db entry %s does not exist" % db_path)
+        return None
+
+    entry = open(db_path).read()
+    dev = udev_parse_block_entry(entry)
+    if dev:
+        # XXX why do we do this? is /sys going to move during installation?
+        dev['sysfs_path'] = sysfs_path[4:]  # strip off the leading '/sys'
+        dev = udev_parse_uevent_file(dev)
+
+    # now add in the contents of the uevent file since they're handy
+    return dev
+
+def udev_parse_uevent_file(dev):
+    path = os.path.normpath("/sys/%s/uevent" % dev['sysfs_path'])
+    if not os.access(path, os.R_OK):
+        return dev
+
+    with open(path) as f:
+        for line in f.readlines():
+            (key, equals, value) = line.strip().partition("=")
+            if not equals:
+                continue
+
+            dev[key] = value
+
+    return dev
+
+def udev_parse_block_entry(buf):
+    dev = {'name': None,
+           'symlinks': []}
+
+    for line in buf.splitlines():
+        line.strip()
+        (tag, sep, val) = line.partition(":")
+        if not sep:
+            continue
+
+        if tag == "N":
+            dev['name'] = val
+        elif tag == "S":
+            dev['symlinks'].append(val)
+        elif tag == "E":
+            if val.count("=") > 1 and val.count(" ") == 1:
+                # eg: LVM2_LV_NAME when querying the VG for its LVs
+                vars = val.split()
+                vals = []
+                var_name = None
+                for (index, subval) in enumerate(vars):
+                    (var_name, sep, var_val) = subval.partition("=")
+                    if sep:
+                        vals.append(var_val)
+
+                dev[var_name] = vals
+            else:
+                (var_name, sep, var_val) = val.partition("=")
+                if not sep:
+                    continue
+
+                if var_val.count(" "):
+                    # eg: DEVLINKS
+                    var_val = var_val.split()
+
+                dev[var_name] = var_val
+
+    if dev.get("name"):
+        return dev
+
+def udev_settle(timeout=None):
+    argv = ["settle"]
+    if timeout:
+        argv.append("--timeout=%d" % int(timeout))
+
+    iutil.execWithRedirect("udevadm", argv, stderr="/dev/null", searchPath=1)
+
+def udev_trigger(subsystem=None):
+    argv = ["trigger"]
+    if subsystem:
+        argv.append("--subsystem-match=%s" % subsystem)
+
+    iutil.execWithRedirect("udevadm", argv, stderr="/dev/null", searchPath=1)
+
+
+""" These are functions for retrieving specific pieces of information from
+    udev database entries.
+"""
+def udev_device_get_name(udev_info):
+    """ Return the best name for a device based on the udev db data. """
+    return udev_info.get("DM_NAME", udev_info["name"])
+
+def udev_device_get_format(udev_info):
+    """ Return a device's format type as reported by udev. """
+    return udev_info.get("ID_FS_TYPE")
+
+def udev_device_get_uuid(udev_info):
+    """ Get the UUID from the device's format as reported by udev. """
+    md_uuid = udev_info.get("MD_UUID")
+    uuid = udev_info.get("ID_FS_UUID")
+    # we don't want to return the array's uuid as a member's uuid
+    if uuid and not md_uuid == uuid:
+        return udev_info.get("ID_FS_UUID")
+
+def udev_device_get_label(udev_info):
+    """ Get the label from the device's format as reported by udev. """
+    return udev_info.get("ID_FS_LABEL")
+
+def udev_device_is_dm(info):
+    """ Return True if the device is a device-mapper device. """
+    return info.has_key("DM_NAME")
+
+def udev_device_is_md(info):
+    """ Return True is the device is an mdraid array device. """
+    return info.has_key("MD_METADATA")
+
+def udev_device_is_cdrom(info):
+    """ Return True if the device is an optical drive. """
+    # FIXME: how can we differentiate USB drives from CD-ROM drives?
+    #         -- USB drives also generate a sdX device.
+    return info.get("ID_CDROM") == "1"
+
+def udev_device_is_disk(info):
+    """ Return True is the device is a disk. """
+    has_range = os.path.exists("/sys/%s/range" % info['sysfs_path'])
+    return info.get("DEVTYPE") == "disk" or has_range
+
+def udev_device_is_partition(info):
+    has_start = os.path.exists("/sys/%s/start" % info['sysfs_path'])
+    return info.get("DEVTYPE") == "partition" or has_start
+
+def udev_device_get_sysfs_path(info):
+    return info['sysfs_path']
+
+def udev_device_get_major(info):
+    return int(info["MAJOR"])
+
+def udev_device_get_minor(info):
+    return int(info["MINOR"])
+
+def udev_device_get_md_level(info):
+    return info["MD_LEVEL"]
+
+def udev_device_get_md_devices(info):
+    return int(info["MD_DEVICES"])
+
+def udev_device_get_md_uuid(info):
+    return info["MD_UUID"]
+
+def udev_device_get_vg_name(info):
+    return info['LVM2_VG_NAME']
+
+def udev_device_get_vg_uuid(info):
+    return info['LVM2_VG_UUID']
+
+def udev_device_get_vg_size(info):
+    # lvm's decmial precision is not configurable, so we tell it to use
+    # KB and convert to MB here
+    return float(info['LVM2_VG_SIZE']) / 1024
+
+def udev_device_get_vg_free(info):
+    # lvm's decmial precision is not configurable, so we tell it to use
+    # KB and convert to MB here
+    return float(info['LVM2_VG_FREE']) / 1024
+
+def udev_device_get_vg_extent_size(info):
+    # lvm's decmial precision is not configurable, so we tell it to use
+    # KB and convert to MB here
+    return float(info['LVM2_VG_EXTENT_SIZE']) / 1024
+
+def udev_device_get_vg_extent_count(info):
+    return int(info['LVM2_VG_EXTENT_COUNT'])
+
+def udev_device_get_vg_free_extents(info):
+    return int(info['LVM2_VG_FREE_COUNT'])
+
+def udev_device_get_vg_pv_count(info):
+    return int(info['LVM2_PV_COUNT'])
+
+def udev_device_get_pv_pe_start(info):
+    # lvm's decmial precision is not configurable, so we tell it to use
+    # KB and convert to MB here
+    return float(info['LVM2_PE_START']) / 1024
+
+def udev_device_get_lv_names(info):
+    names = info['LVM2_LV_NAME']
+    if not names:
+        names = []
+    elif not isinstance(names, list):
+        names = [names]
+    return names
+
+def udev_device_get_lv_uuids(info):
+    uuids = info['LVM2_LV_UUID']
+    if not uuids:
+        uuids = []
+    elif not isinstance(uuids, list):
+        uuids = [uuids]
+    return uuids
+
+def udev_device_get_lv_sizes(info):
+    # lvm's decmial precision is not configurable, so we tell it to use
+    # KB and convert to MB here
+    sizes = info['LVM2_LV_SIZE']
+    if not sizes:
+        sizes = []
+    elif not isinstance(sizes, list):
+        sizes = [sizes]
+
+    return [float(s) / 1024 for s in sizes]
+
+
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/text.py anaconda-storage/text.py
--- anaconda/text.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/text.py	2009-02-15 15:40:45.000000000 -0600
@@ -629,10 +629,6 @@
         # draw the frame after setting up the fallback
         self.drawFrame()
 
-        anaconda.id.fsset.registerMessageWindow(self.messageWindow)
-        anaconda.id.fsset.registerProgressWindow(self.progressWindow)
-        anaconda.id.fsset.registerWaitWindow(self.waitWindow)
-
 	lastrc = INSTALL_OK
 	(step, instance) = anaconda.dispatch.currentStep()
 	while step:
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/upgrade.py anaconda-storage/upgrade.py
--- anaconda/upgrade.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/upgrade.py	2009-02-17 13:29:52.000000000 -0600
@@ -26,14 +26,13 @@
 import time
 import sys
 import os.path
-import partedUtils
 import string
 import selinux
-import lvm
 from flags import flags
-from fsset import *
 from constants import *
 from product import productName
+from storage import findExistingRootDevices, FSTab
+from storage.formats import getFormat
 
 import rhpl
 import rhpl.arch
@@ -135,10 +134,7 @@
 
     anaconda.id.upgradeRoot = []
     for (dev, fs, meta, label, uuid) in anaconda.id.rootParts:
-        if (root_device is not None) and ((dev == root_device) or (("UUID=%s" % uuid) == root_device) or (("LABEL=%s" % label) == root_device)):
-            anaconda.id.upgradeRoot.append( (dev, fs) )
-        else:
-            anaconda.id.upgradeRoot.append( (dev, fs) )
+        anaconda.id.upgradeRoot.append( (dev, fs) )
 
     if anaconda.id.rootParts is not None and len(anaconda.id.rootParts) > 0:
         anaconda.dispatch.skipStep("findinstall", skip = 0)
@@ -149,7 +145,9 @@
         anaconda.dispatch.skipStep("installtype", skip = 0)
 
 def findExistingRoots(anaconda, upgradeany = 0):
+    # FIXME: this should not live here
     # make ibft configured iscsi disks available
+    # FIXME: this should be handled by the device tree
     anaconda.id.iscsi.startup(anaconda.intf)
 
     if not flags.setupFilesystems:
@@ -157,105 +155,18 @@
         if ((flags.cmdline.has_key("upgradeany")) or
             (upgradeany == 1) or
             (partedUtils.productMatches(relstr, productName))):
-            return [(anaconda.rootPath, 'ext2', "")]
+            return [(anaconda.rootPath, "")]
         return []
 
-    anaconda.id.diskset.openDevices()
-    anaconda.id.partitions.getEncryptedDevices(anaconda.id.diskset)
-    rootparts = anaconda.id.diskset.findExistingRootPartitions(upgradeany = upgradeany)
-
-    # close the devices to make sure we don't leave things sitting open 
-    anaconda.id.diskset.closeDevices()
-
-    # this is a hack... need to clear the skipped disk list after this
-    partedUtils.DiskSet.skippedDisks = []
-    partedUtils.DiskSet.exclusiveDisks = []
-
+    # TODO: figure out why there was a need to clear skippedDisks after this
+    rootparts = findExistingRootDevices(anaconda, upgradeany=upgradeany)
     return rootparts
 
-def getDirtyDevString(dirtyDevs):
-    ret = ""
-    for dev in dirtyDevs:
-        if dev != "loop":
-            ret = "/dev/%s\n" % (dev,)
-        else:
-            ret = "%s\n" % (dev,)
-    return ret
-
-def mountRootPartition(anaconda, rootInfo, oldfsset, allowDirty = 0,
-		       warnDirty = 0, readOnly = 0):
-    (root, rootFs) = rootInfo
-    bindMount = 0
-
-    encryptedDevices = anaconda.id.partitions.encryptedDevices
-    diskset = partedUtils.DiskSet(anaconda)
-    diskset.openDevices()
-    for cryptoDev in encryptedDevices.values():
-        cryptoDev.openDevice()
-    diskset.startMPath()
-    diskset.startDmRaid()
-    diskset.startMdRaid()
-    for cryptoDev in encryptedDevices.values():
-        cryptoDev.openDevice()
-    lvm.vgscan()
-    lvm.vgactivate()
-    for cryptoDev in encryptedDevices.values():
-        cryptoDev.openDevice()
-
-    if root in anaconda.id.partitions.protectedPartitions() and os.path.ismount("/mnt/isodir"):
-        root = "/mnt/isodir"
-        bindMount = 1
-
-    log.info("going to mount %s on %s as %s" %(root, anaconda.rootPath, rootFs))
-    isys.mount(root, anaconda.rootPath, rootFs, bindMount=bindMount)
-
-    oldfsset.reset()
-    newfsset = readFstab(anaconda)
-
-    for entry in newfsset.entries:
-        oldfsset.add(entry)
-
-    if not bindMount:
-        isys.umount(anaconda.rootPath)
-
-    dirtyDevs = oldfsset.hasDirtyFilesystems(anaconda.rootPath)
-    if not allowDirty and dirtyDevs != []:
-        lvm.vgdeactivate()
-        diskset.stopMdRaid()
-        diskset.stopDmRaid()
-        diskset.stopMPath()
-        anaconda.intf.messageWindow(_("Dirty File Systems"),
-                           _("The following file systems for your Linux system "
-                             "were not unmounted cleanly.  Please boot your "
-                             "Linux installation, let the file systems be "
-                             "checked and shut down cleanly to upgrade.\n"
-                             "%s" %(getDirtyDevString(dirtyDevs),)))
-        sys.exit(0)
-    elif warnDirty and dirtyDevs != []:
-        rc = anaconda.intf.messageWindow(_("Dirty File Systems"),
-                                _("The following file systems for your Linux "
-                                  "system were not unmounted cleanly.  Would "
-                                  "you like to mount them anyway?\n"
-                                  "%s" % (getDirtyDevString(dirtyDevs,))),
-                                type = "yesno")
-        if rc == 0:
-            return -1
-
-    if flags.setupFilesystems:
-        for dev, crypto in encryptedDevices.items():
-            if crypto.openDevice():
-                log.error("failed to open encrypted device %s" % (dev,))
-
-        oldfsset.mountFilesystems(anaconda, readOnly = readOnly,
-                                  skiprootfs = bindMount)
-
-    rootEntry = oldfsset.getEntryByMountPoint("/")
-    if (not rootEntry or not rootEntry.fsystem or not rootEntry.fsystem.isMountable()):
-        raise RuntimeError, "/etc/fstab did not list a fstype for the root partition which we support"
-
 def bindMountDevDirectory(instPath):
-    fs = fileSystemTypeGet("bind")
-    fs.mount("/dev", "/dev", bindMount=1, instroot=instPath)
+    getFormat("bind",
+              device="/dev",
+              mountpoint="/dev",
+              exists=True).mount(chroot=instPath)
 
 # returns None if no filesystem exist to migrate
 def upgradeMigrateFind(anaconda):
@@ -297,13 +208,15 @@
 
     fsList = []
 
-    for entry in anaconda.id.fsset.entries:
-        if entry.fsystem.getName() in getUsableLinuxFs():
-            if flags.setupFilesystems and not entry.isMounted():
+    for device in anaconda.id.fsset.devices:
+        if not device.format:
+            continue
+        if device.format.mountable and device.format.linuxNative:
+            if flags.setupFilesystems and not device.format.status:
                 continue
-            space = isys.pathSpaceAvailable(anaconda.rootPath + entry.mountpoint)
+            space = isys.pathSpaceAvailable(anaconda.rootPath + device.format.mountpoint)
             if space > 16:
-                info = (entry.mountpoint, entry.device.getDevice(), space)
+                info = (device, space)
                 fsList.append(info)
 
     suggestion = mem * 2 - swap
@@ -313,57 +226,11 @@
         suggestion = 32
     suggSize = 0
     suggMnt = None
-    for (mnt, part, size) in fsList:
+    for (device, size) in fsList:
 	if (size > suggSize) and (size > (suggestion + 100)):
-	    suggMnt = mnt
+	    suggDev = device
 
-    anaconda.id.upgradeSwapInfo = (fsList, suggestion, suggMnt)
-
-def swapfileExists(swapname):
-    try:
-        os.lstat(swapname)
-	return 1
-    except:
-	return 0
-
-def createSwapFile(instPath, theFsset, mntPoint, size):
-    fstabPath = instPath + "/etc/fstab"
-    prefix = ""
-
-    if mntPoint != "/":
-        file = mntPoint + "/SWAP"
-    else:
-        file = "/SWAP"
-
-    swapFileDict = {}
-    for entry in theFsset.entries:
-        if entry.fsystem.getName() == "swap":
-            swapFileDict[entry.device.getName()] = 1
-        
-    count = 0
-    while (swapfileExists(instPath + file) or 
-	   swapFileDict.has_key(file)):
-	count = count + 1
-	tmpFile = "/SWAP-%d" % (count)
-        if mntPoint != "/":
-            file = mntPoint + tmpFile
-        else:
-            file = tmpFile
-
-    device = SwapFileDevice(file)
-    device.setSize(size)
-    fsystem = fileSystemTypeGet("swap")
-    entry = FileSystemSetEntry(device, "swap", fsystem)
-    entry.setFormat(1)
-    theFsset.add(entry)
-    theFsset.formatEntry(entry, instPath)
-    theFsset.turnOnSwap(instPath, upgrading=True)
-
-    # XXX generalize fstab modification
-    f = open(fstabPath, "a")
-    format = "%-23s %-23s %-7s %-15s %d %d\n";
-    f.write(format % (prefix + file, "swap", "swap", "defaults", 0, 0))
-    f.close()
+    anaconda.id.upgradeSwapInfo = (fsList, suggestion, suggDev)
 
 # XXX handle going backwards
 def upgradeMountFilesystems(anaconda):
@@ -371,21 +238,15 @@
 
     if flags.setupFilesystems:
 	try:
-	    mountRootPartition(anaconda, anaconda.id.upgradeRoot[0], anaconda.id.fsset,
-                               allowDirty = 0)
-        except SystemError:
+	    mountExistingSystem(anaconda,
+                                anaconda.id.upgradeRoot[0],
+                                allowDirty = 0)
+        except Exception:
 	    anaconda.intf.messageWindow(_("Mount failed"),
 		_("One or more of the file systems listed in the "
 		  "/etc/fstab on your Linux system cannot be mounted. "
 		  "Please fix this problem and try to upgrade again."))
 	    sys.exit(0)
-        except RuntimeError:
-            anaconda.intf.messageWindow(_("Mount failed"),
-		_("One or more of the file systems listed in the "
-                  "/etc/fstab of your Linux system are inconsistent and "
-                  "cannot be mounted.  Please fix this problem and try to "
-                  "upgrade again."))
-            sys.exit(0)
 
 	checkLinks = ( '/etc', '/var', '/var/lib', '/var/lib/rpm',
 		       '/boot', '/tmp', '/var/tmp', '/root',
@@ -432,13 +293,11 @@
                                         % (anaconda.rootPath + "/etc/fstab",),
                                         type="ok")
             return DISPATCH_BACK
-            
-	newfsset = readFstab(anaconda)
-        for entry in newfsset.entries:
-            anaconda.id.fsset.add(entry)
+
+        newfsset = FSSet(anaconda.id.devicetree)
+        newfsset.parseFSTab(chroot=anaconda.rootPath)
+        anaconda.id.fsset = newfsset
     if flags.setupFilesystems:
-        if iutil.isPPC():
-            anaconda.id.fsset.formatSwap(anaconda.rootPath, forceFormat=True)
         anaconda.id.fsset.turnOnSwap(anaconda.rootPath, upgrading=True)
         anaconda.id.fsset.mkDevRoot(anaconda.rootPath)
 
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/yuminstall.py anaconda-storage/yuminstall.py
--- anaconda/yuminstall.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/yuminstall.py	2009-02-17 13:31:19.000000000 -0600
@@ -1293,26 +1293,17 @@
         elif iutil.isIA64():
             self.selectPackage("elilo")
 
-    def selectFSPackages(self, fsset, diskset):
-        for entry in fsset.entries:
-            map(self.selectPackage, entry.fsystem.getNeededPackages())
-            if entry.device.crypto:
-                self.selectPackage("cryptsetup-luks")
+    def selectFSPackages(self, storage):
+        for device in storage.fsset.devices:
+            # this takes care of device and filesystem packages
+            map(self.selectPackage, device.packages)
 
-        for disk in diskset.disks.keys():
-            if isys.driveIsIscsi(disk):
+        for disk in storage.disks:
+            if isys.driveIsIscsi(disk.path):
                 log.info("ensuring iscsi is installed")
                 self.selectPackage("iscsi-initiator-utils")
                 break
 
-        if diskset.__class__.mpList:
-            log.info("ensuring device-mapper-multipath is installed")
-            self.selectPackage("device-mapper-multipath")
-        if diskset.__class__.dmList:
-            log.info("ensuring dmraid is installed")
-            self.selectPackage("dmraid")
-
-
     # anaconda requires several programs on the installed system to complete
     # installation, but we have no guarantees that some of these will be
     # installed (they could have been removed in kickstart).  So we'll force
@@ -1335,7 +1326,7 @@
             # New installs only - upgrades will already have all this stuff.
             self.selectBestKernel(anaconda)
             self.selectBootloader()
-            self.selectFSPackages(anaconda.id.fsset, anaconda.id.diskset)
+            self.selectFSPackages(anaconda.id.storage)
             self.selectAnacondaNeeds()
 
         if anaconda.id.getUpgrade():
